- [HTTP request](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.PATH_PARAMETERS)
- [Request body](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.request_body)
  - [JSON representation](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.request_body.SCHEMA_REPRESENTATION)
    - [JSON representation](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.request_body.SCHEMA_REPRESENTATION.product.SCHEMA_REPRESENTATION)
    - [JSON representation](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.request_body.SCHEMA_REPRESENTATION.product.SCHEMA_REPRESENTATION_1)
    - [JSON representation](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.request_body.SCHEMA_REPRESENTATION.product.SCHEMA_REPRESENTATION_2)
    - [JSON representation](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.request_body.SCHEMA_REPRESENTATION.product.SCHEMA_REPRESENTATION_3)
    - [JSON representation](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.request_body.SCHEMA_REPRESENTATION.product.SCHEMA_REPRESENTATION_4)
    - [JSON representation](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.request_body.SCHEMA_REPRESENTATION.product.SCHEMA_REPRESENTATION_5)
    - [JSON representation](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.request_body.SCHEMA_REPRESENTATION.product.SCHEMA_REPRESENTATION_6)
    - [JSON representation](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.request_body.SCHEMA_REPRESENTATION.product.SCHEMA_REPRESENTATION_7)
- [Response body](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.response_body)
- [Authorization scopes](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#body.aspect)
- [Examples](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#examples)
- [Try it!](https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products/patch#try-it)

Updates a product.

### HTTP request

`PATCH https://dv360seller.googleapis.com/v1beta1/{product.name=exchanges/*/orders/*/products/*}`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `product.name` | `string` Relative resource name for product. Generated by server. Example: "exchanges/1234/orders/5678/products/abc". Output only. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "product": { "name": string, "displayName": string, "externalDealId": string, "transactionType": enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/TransactionType`), "pricingType": enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/PricingType`), "updateTime": string, "startTime": string, "endTime": string, "rateDetails": { "rateType": enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/RateDetails#RateType`), "rate": { object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/Money`) }, "unitsPurchasedCount": string }, "creativeConfig": [ { "creativeType": enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#CreativeType`), "dimensionCreativeConfig": { object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#DimensionCreativeConfig`) }, "durationCreativeConfig": { object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#DurationCreativeConfig`) } } ], "makegood": boolean, "makegoodDetails": { "originalExternalDealId": string, "reason": string }, "creativeSource": enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#CreativeSource`), "mediumType": enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/MediumType`), "audienceTargetingConfig": { "audienceType": enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#AudienceType`) }, "targetingCriteria": { "selectedTargetingOptions": [ { object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#SelectedTargetingOption`) } ] }, "forecastResult": { "forecasts": [ { object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#Forecast`) } ] }, "errorDetails": { "message": string, "instantDealErrorStatus": enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#InstantDealErrorStatus`) }, "frequencyCap": { "timeUnit": enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#TimeUnit`), "maxImpressions": string }, "program": string, "buyerCustomParameters": { string: string, ... }, "etag": string }, "updateMask": string } ``` |

| Fields ||
|---|---|
| `product.displayName` | `string` The display name of the product. Must be UTF-8 encoded with a maximum size of 240 bytes. Required. |
| `product.externalDealId` | `string` External ID. This is the deal ID on exchange system. Max 100 characters. Allowed characters are alphanumeric, underscore, dash, and dot. Must be unique across all products. Required. |
| `product.transactionType` | ``enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/TransactionType`)`` Product transaction type. Required. |
| `product.pricingType` | ``enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/PricingType`)`` Pricing type for product. Required. |
| `product.updateTime (deprecated)` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` The timestamp when the product was last updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `product.startTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Time when this product becomes active. Must be earlier than endTime. Start time cannot be more than 1 year in the future. Required. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `product.endTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Time when this product becomes inactive. Cannot be later than year 2036. Required. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `product.rateDetails` | ``object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/RateDetails`)`` Rate details. Required. |
| `product.creativeConfig[]` | ``object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#CreativeConfig`)`` The creative requirements for a product. Required for reserved transaction type product. |
| `product.makegood (deprecated)` | `boolean` Denotes whether a product is a makegood product. |
| `product.makegoodDetails (deprecated)` | ``object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#MakegoodDetails`)`` The makegood details for a product. Required when the product is a makegood. |
| `product.creativeSource` | ``enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#CreativeSource`)`` Creative source for a product. Optional, defaults to CREATIVE_SOURCE_ADVERTISER. Cannot be changed after product creation. |
| `product.mediumType` | ``enum (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/MediumType`)`` Medium type for a product. Defaults to DIGITAL if not specified for backwards compatibility. Cannot be changed after product creation. |
| `product.audienceTargetingConfig` | ``object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#AudienceTargetingConfig`)`` Optional. Audience targeting config applied at deal level on the exchange. |
| `product.targetingCriteria` | ``object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#TargetingCriteria`)`` Output only. Product targeting criteria references. Only applicable to Instant Deal Scenarios. |
| `product.forecastResult` | ``object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#ForecastResult`)`` Product forecast results. Required when the targeting criteria are not empty and the forecast is not provided. Only applicable to Instant Deal Scenarios. |
| `product.errorDetails` | ``object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#ErrorDetails`)`` Error details must be specified when specific product fields cannot be updated. Required when the forecast result cannot be provided due to a targeting criterion or an update cannot be made to the product. Only applicable to Instant Deal Scenarios. |
| `product.frequencyCap` | ``object (`https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#FrequencyCap`)`` Output only. Frequency cap selected by the buyer. Only applicable to Instant Deal Scenarios. |
| `product.program` | `string` Output only. The program under which the buyer created the instant deal. Empty for the regular flow of the exchange. Only applicable to Instant Deal Scenarios. |
| `product.buyerCustomParameters` | `map (key: string, value: string)` Output only. Custom key/value parameters set by the buyer on the instant deal request. Only applicable to Instant Deal Scenarios. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `product.etag` | `string` An etag that needs to be specified when updating a product. It only needs to be specified for an update if the etag field is not empty. Only applicable to Instant Deal Scenarios. |
| `updateMask` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#field-mask` format)`` The mask to control which fields to update. Required. This is a comma-separated list of fully qualified names of fields. Example: `"user.displayName,photo"`. |

### Response body

If successful, the response body contains an instance of `https://developers.google.com/display-video/seller/reference/rest/v1beta1/exchanges.orders.products#Product`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/doubleclickbidmanager`

For more information, see the [OAuth 2.0 Overview](https://developers.google.com/identity/protocols/OAuth2).